#ifndef MDD_IMODULE_H
#define MDD_IMODULE_H

#include "IOutput.h"
#include <string>
#include <vector>
#include <memory>

class IModule{
public:
    virtual bool connectInput(std::string input_name, std::shared_ptr<IOutput> output) = 0;
    virtual std::vector<std::string> getInputs() = 0;
    virtual void setInput(std::string name, std::shared_ptr<IOutput> output) = 0;
    virtual ~IModule(){};
};

#endif //MDD_IMODULE_H
